﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using System.IO;
using System.Xml;

namespace ServiceMonitoring
{
    /// <summary>
    /// 名称：规则配置类。
    /// 说明：用于读取和修改规则信息。
    /// 作者：kmiaoer
    /// 时间: 20171212
    /// </summary>
    public class RuleConfig
    {

        private static string fileurl = System.Windows.Forms.Application.StartupPath.Replace("bin\\Debug", "") + "RuleConfig.xml";

        static object obj = new object();
        /// <summary>
        /// 获取配置信息
        /// </summary>
        /// <returns></returns>
        public static List<Model.RuleInfo> GetConfig()
        {
            try
            {
                List<Model.RuleInfo> ResultList = new List<Model.RuleInfo>();
                XmlDocument doc = new XmlDocument();
                doc.Load(fileurl);    //加载Xml文件 
                XmlNode gennode = doc.SelectSingleNode("monitoring");
                for (int i = 0; i < gennode.ChildNodes.Count; i++)
                {
                    var zinode = gennode.ChildNodes[i].ChildNodes;
                    Model.RuleInfo model = new Model.RuleInfo();
                    for (int j = 0; j < zinode.Count; j++)
                    {
                        model.Id = Convert.ToInt32(zinode[0].InnerText);
                        model.MClass = Convert.ToInt32(zinode[1].InnerText);
                        model.MClassName = Model.ConvertName.ClassName(model.MClass);

                        model.MName = zinode[2].InnerText.Trim();
                        model.Content = zinode[3].InnerText.Trim();
                        model.SqlString = zinode[4].InnerText;
                        model.Interval = Convert.ToInt32(zinode[5].InnerText);
                        model.Result = zinode[6].InnerText;
                        model.Handle = Convert.ToInt32(zinode[7].InnerText);
                        model.HandleName = Model.ConvertName.HandleName(model.Handle);

                        model.State = Convert.ToInt32(zinode[8].InnerText);
                        model.StateName = Model.ConvertName.StateName(model.State);
                        model.Mobile = zinode[9].InnerText;
                        model.CTime = zinode[10].InnerText;
                    }
                    ResultList.Add(model);

                }
                return ResultList;

            }
            catch (Exception ex)
            {
                return null;
            }
        }
        /// <summary>
        /// 设置信息状态.
        /// </summary> 
        public static void SetState(int id, int state)
        {
            ///锁一下，防止多更改冲突。
            lock (obj)
            {
                XmlDocument doc = new XmlDocument();
                doc.Load(fileurl);    //加载Xml文件 
                XmlNode gennode = doc.SelectSingleNode("monitoring");
                for (int i = 0; i < gennode.ChildNodes.Count; i++)
                {
                    var zinode = gennode.ChildNodes[i].ChildNodes;
                    if (zinode.Item(0).InnerText == id.ToString())
                    {
                        zinode.Item(8).InnerText = state.ToString();
                        zinode.Item(10).InnerText =   DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
                    }
                }
                doc.Save(fileurl);
           }
            
        }
    }
}
