﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using Newtonsoft.Json;
using System.Net;
namespace ServiceMonitoring
{
    public partial class Main : Form
    {
        public Main()
        {
            InitializeComponent();
        }
        private void ShowData()
        {
            dataGridView1.AutoGenerateColumns = false; 
            dataGridView1.DataSource = RuleConfig.GetConfig(); 
        }
        private void Main_Load(object sender, EventArgs e)
        {
            btnEnd.Enabled = false;
            ShowData();
        }

        private void btnBegin_Click(object sender, EventArgs e)
        {
            btnBegin.Enabled = false;
            btnEnd.Enabled = true;
            Service.BService.State = true;
            Service.BService.BeginTiem = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
            var RuleInfo = RuleConfig.GetConfig();  
            ThreadPool.SetMaxThreads(RuleInfo.Count, RuleInfo.Count);
            for (int i = 0; i < RuleInfo.Count; i++)
            { 
                var t = Service.ServiceFactory.CreateService(RuleInfo[i].MClass);
                ThreadPool.QueueUserWorkItem(t.Checkout, JsonConvert.SerializeObject(RuleInfo[i]));
            } 
        }

        private void button1_Click(object sender, EventArgs e)
        {
            ShowData();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            RuleConfig.SetState(2, 9);
        } 
        private void timer1_Tick(object sender, EventArgs e)
        {
            toolStripStatusLabel1.Text = "状态:" + (Service.IISService.State ? "运行" : "停止"); 
            toolStripStatusLabel2.Text = (string.IsNullOrEmpty(Service.IISService.BeginTiem) ? "" : "开始时间:" + Service.IISService.BeginTiem);
            ShowData();
        } 
        private void btnEnd_Click(object sender, EventArgs e)
        {
            btnBegin.Enabled = true;
            btnEnd.Enabled = false;
            Service.BService t = new Service.BService();
            t.End();
        } 
    }
}
