﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServiceMonitoring.Model
{   
    /// <summary>
    /// 名称：规则对象
    /// 说明：用户对象保存
    /// 作者：kmiaoer
    /// 时间: 20171212
    /// </summary>
    public class RuleInfo
    {
        /// <summary>
        /// ID
        /// </summary>
        public int Id { get; set; }
        /// <summary>
        /// 类型。1 IIS。2 DB。3 业务逻辑
        /// </summary>
        public int MClass { get; set; }
        /// <summary>
        /// 类型名称
        /// </summary>
        public string MClassName { get; set; }
        /// <summary>
        /// 名称
        /// </summary>
        public string MName { get; set; }
        /// <summary>
        /// 内容。1 IIS地址。2 DB数据库链接字符串。3 DB数据库链接字符串。
        /// 注意：如果是DB数据库链接字符串。添加关闭连接池.Pooling=false.
        /// </summary>
        public string Content { get; set; }
        /// <summary>
        /// sql 语句。主要用户业务逻辑监测。
        /// </summary>
        public string SqlString { get; set; }
        /// <summary>
        /// 间隔（秒）用于探测的时间间隔。
        /// </summary>
        public int Interval { get; set; }
        /// <summary>
        /// 返回结果。
        /// 1 如果是IIS 则返回字符 ok 。 
        /// 2 如果是db及业务逻辑则返回int。如果大于此值则出发报警。
        /// </summary>
        public string Result { get; set; }
        /// <summary>
        /// 处理方法。当出现错误时候如何处理。0  忽略。1 短信通知管理员
        /// </summary>
        public int Handle { get; set; }
        /// <summary>
        /// 处理方法名称。
        /// </summary>
        public string HandleName { get; set; }
        /// <summary>
        /// 状态。0 正常。1 异常
        /// </summary>
        public int State { get; set; }
        /// <summary>
        /// 状态名称。
        /// </summary>
        public string StateName { get; set; }
        /// <summary>
        /// 手机号。当发现错误后通知人的手机号。多个号码,号隔开。
        /// </summary>
        public string Mobile { get; set; }
        /// <summary>
        /// 检测时间
        /// </summary>
        public string CTime { get; set; }
    }
    /// <summary>
    /// 名称：类型转换
    /// 说明： 
    /// 作者：kmiaoer
    /// 时间: 20171212
    /// </summary>
    public class ConvertName
    { 
        /// <summary>
        /// 1 IIS, 2 SQLServer,3 业务逻辑
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public  static string ClassName(int id)
        {
            var name = "";
            switch(id)
            {
                case 1:
                    name = "IIS";
                    break;
                case 2:
                    name = "SQLServer";
                    break;
                case 3:
                    name = "业务逻辑";
                    break;
                default:
                    name = "错误";
                    break;
            }
            return name;
        }
        /// <summary>
        /// 0 忽略。1 短信通知
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public static string HandleName(int id)
        {
            var name = "";
            switch (id)
            {
                case 0:
                    name = "忽略";
                    break;
                case 1:
                    name = "短信通知";
                    break; 
                default:
                    name = "错误";
                    break;
            }
            return name;
        }
        /// <summary>
        /// 0 正常。1 异常
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public static string StateName(int id)
        {
            var name = "";
            switch (id)
            {
                case 0:
                    name = "正常";
                    break;
                case 1:
                    name = "异常";
                    break;
                default:
                    name = "错误";
                    break;
            }
            return name;
        }
    }

}
