﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
namespace ServiceMonitoring.Service
{
    /// <summary>
    /// 名称：服务基础类。
    /// 说明：用于保存服务一些基础方法及服务状态。
    /// 作者：kmiaoer
    /// 时间: 20171212
    /// </summary>
    public class BService
    {
        public BService()
        { 
            
        }
        /// <summary>
        /// 检测方法。改方法为虚方法，具体执行见子类
        /// </summary>
        /// <param name="data"></param>
        public virtual void Checkout(object data)
        { 
              
        }

        public static object lockobj = new object();
        /// <summary>
        /// 执行状态
        /// </summary>
        public static bool State = false;
        /// <summary>
        /// 执行开始时间
        /// </summary>
        public static string BeginTiem = "";
        /// <summary>
        /// 发送短信。短信通知管理员
        /// </summary>
        /// <param name="mobileList"></param>
        /// <param name="Rule"></param>
        private static void SendMessage(Model.RuleInfo RuleInfo)
        {
            var mobile = RuleInfo.Mobile.Split(',');
            for (int i = 0; i < mobile.Length; i++)
            {
                Message.Send(mobile[i].ToString(), string.Format("ID:{0}.名字:{1}.发生错误请及时处理 ", RuleInfo.Id, RuleInfo.MName));
            }
            
        }
        /// <summary>
        /// 写入错误日志
        /// </summary>
        /// <param name="RuleInfo"></param>
        private static void WriteLog(Model.RuleInfo RuleInfo)
        { 
            string fileurl =  System.Windows.Forms.Application.StartupPath.Replace("bin\\Debug", "") + "/Log/"+ DateTime.Now.ToString("yyyy-MM-dd")+".txt";
            using (StreamWriter writer = new StreamWriter(fileurl,true))
            {
                var str = string.Format("\n{0}--ID：{1}。名称：{2}。处理方式：{3} ", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"), RuleInfo.Id, RuleInfo.MName, Model.ConvertName.HandleName(RuleInfo.Handle));
                writer.WriteLine(str);
                writer.Close();
            }  
        }
        /// <summary>
        /// 失败方法。
        /// </summary>
        /// <param name="info"></param>
        public static void Err(Model.RuleInfo RuleInfo)
        {
            lock (lockobj)
            {
                if (RuleInfo.Handle == 1)
                {
                    SendMessage(RuleInfo);
                }
                WriteLog(RuleInfo);
                RuleConfig.SetState(RuleInfo.Id, 1); 
            } 
        }
        /// <summary>
        /// 成功方法
        /// </summary>
        /// <param name="RuleInfo"></param>
        public static void Success(Model.RuleInfo RuleInfo)
        {
            RuleConfig.SetState(RuleInfo.Id, 0); 
        }
        /// <summary>
        /// 结束检测
        /// </summary>
        public void End()
        {
            State = false;
           
        }
        
    }
}
