﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Collections.Generic;  
using System.Threading;
using Newtonsoft.Json;

namespace ServiceMonitoring.Service
{
    /// <summary>
    /// 名称：数据库检测类。
    /// 说明： 
    /// 作者：kmiaoer
    /// 时间: 20171212
    /// </summary>
    public class DBService : BService
    {
        /// <summary>
        /// 开始检测DB。
        /// </summary>
        /// <param name="data">规则json</param>
        public override void Checkout(object data)
        {
             
            var strJson = data as string;
            var Rule = JsonConvert.DeserializeObject<Model.RuleInfo>(strJson);
              
            while (State)
            {
                using (var mySqlConnection = new SqlConnection(Rule.Content))
                {
                    try
                    {
                        if (mySqlConnection.State == ConnectionState.Closed)
                        {
                            mySqlConnection.Open();
                        }
                        if (mySqlConnection.State == ConnectionState.Open)
                        {
                            BService.Success(Rule);
                            mySqlConnection.Close();
                        }
                        else
                        {
                            BService.Err(Rule); 
                        }
                    }
                    catch (Exception ex)
                    {
                        BService.Err(Rule);
                    }
                    finally
                    { 
                        Thread.Sleep(Rule.Interval * 1000);
                    }
                }
            } 
        }
    }
}
