﻿using System;
using System.Collections.Generic; 
using System.Net;
using System.Threading;
using Newtonsoft.Json;
namespace ServiceMonitoring.Service
{    
    /// <summary>
    /// 名称：IIS检测类。
    /// 说明： 
    /// 作者：kmiaoer
    /// 时间: 20171212
    /// </summary>
    public class IISService : BService
    { 
        /// <summary>
        /// 开始检测IIS。
        /// </summary>
        /// <param name="data">规则json</param>
        public override void Checkout(object data)
        {
  
            var strJson = data as string;
            var Rule = JsonConvert.DeserializeObject<Model.RuleInfo>(strJson);
            while (State)
            { 
                HttpWebRequest myHttpWebRequest = null;
                HttpWebResponse myHttpWebResponse = null; 
                string HttpWebResult = "";
                System.Net.ServicePointManager.DefaultConnectionLimit = 512; 
                try
                {
                    myHttpWebRequest = (HttpWebRequest)WebRequest.Create(Rule.Content);
                    myHttpWebRequest.Method = "GET";
                    myHttpWebRequest.AllowAutoRedirect = true;
                    myHttpWebRequest.KeepAlive = false;
                    myHttpWebRequest.ServicePoint.Expect100Continue = false; 
                    myHttpWebResponse = (HttpWebResponse)myHttpWebRequest.GetResponse();
                    HttpWebResult = myHttpWebResponse.StatusCode.ToString();
                    myHttpWebResponse.Close(); 
                }
                catch (Exception ex)
                {
                    HttpWebResult = "err";
                }
                finally
                { 
                    myHttpWebRequest = null;
                    myHttpWebResponse = null;
                    if (HttpWebResult.ToLower() == Rule.Result)
                    {
                        BService.Success(Rule);
                    }
                    else
                    {
                        BService.Err(Rule);
                    }
                    Thread.Sleep(Rule.Interval * 1000); 
                }  
            }

        }
   
    }
}
